*Mapple* is free software for processing and visualizing point clouds and polygonal models. Key features include:
- quite a few well-known algorithms for processing point clouds (e.g., normal estimation, downsampling, Delaunay triangulation, Poisson reconstruction) and polygonal models (e.g., simplification, subdivision, smoothing, segmentation, remeshing, tetrahedralization);
- a variety of commonly used and customized file formats, e.g., ply, obj, off, stl, las, laz, xyz, pn, pc, pnc, vg, plg, bin, mesh;
- management of multiple objects in a single window;
- the use of modern GPU features for rendering and interacting with huge point clouds and polygonal models, e.g., soft shadow, transparancy (tunable per object), ambient occlusion, EDL (Eye Dome Lighting), clipping plane/cross section, point/line imposers(i.e., points as spheres, lines as cylinders/cones;
- various interactive editing tools, e.g., selection, object/component manipulation;
- a nice and friendly user interface, e.g., copy/restore camera, walkthrough. 

---

**System requirements**: Graphics cards and display drivers that support OpenGL version >= 4.3.

**Known issues**: Shadowing with AMD graphcs cards is not working (I will try to fix this soon).  

**TODO**: Backward compatibility (for machines that do not support OpenGL 4.3 or higher), e.g., Apple stubbornly does not support OpenGL higher than 4.1.

---

**Donate to support software development**:
	Mapple is free. You can download and use it without any limitations. If you find Mapple useful please consider making a donation to help support and future development. Any amount is appreciated. 
	Please send me an email (liangliang.nan@gmail.com) if you would like to donate.

---

I'd like to thank you for offering suggestions and pointing out problems!
If you have any suggestions for improvements or bug reports you're most welcome to contact me at liangliang.nan@gmail.com. 
  

**_Liangliang Nan_**

https://3d.bk.tudelft.nl/liangliang/

July 18, 2017

Copyright (C) 2017 
